#ifndef _OgreBoundingBoxConverter_H__
#define _OgreBoundingBoxConverter_H__
 
#include "OgreAxisAlignedBox.h"
#include "AxisAlignedBox3.h"
#include "Vector3.h"
#include "BoundingBoxConverter.h"
#include "Containers.h"

namespace Ogre {

class Entity;
class OctreeSceneManager;

/**	Class which converts preprocessor types to OGRE types
*/
class __declspec(dllexport) OgreBoundingBoxConverter: public GtpVisibilityPreprocessor::BoundingBoxConverter
{
public:
	OgreBoundingBoxConverter(OctreeSceneManager *sm);

	bool IdentifyObjects(const GtpVisibilityPreprocessor::IndexedBoundingBoxContainer &iboxes,
						 GtpVisibilityPreprocessor::ObjectContainer &objects) const;


protected:

	Entity *FindCorrespondingObject(const AxisAlignedBox &box) const;

	OctreeSceneManager *mSceneMgr;
};

} // namespace Ogre

#endif // OgreBoundingBoxConverter
